• HDU Count the string (KMP)


    Count the string

    Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 32768/32768K (Java/Other)
    Total Submission(s) : 22   Accepted Submission(s) : 11
    Problem Description
    It is well known that AekdyCoin is good at string problems as well as number theory problems. When given a string s, we can write down all the non-empty prefixes of this string. For example: s: "abab" The prefixes are: "a", "ab", "aba", "abab" For each prefix, we can count the times it matches in s. So we can see that prefix "a" matches twice, "ab" matches twice too, "aba" matches once, and "abab" matches once. Now you are asked to calculate the sum of the match times for all the prefixes. For "abab", it is 2 + 2 + 1 + 1 = 6. The answer may be very large, so output the answer mod 10007.
     
    Input
    The first line is a single integer T, indicating the number of test cases. For each case, the first line is an integer n (1 <= n <= 200000), which is the length of string s. A line follows giving the string s. The characters in the strings are all lower-case letters.
     
    Output
    For each case, output only one number: the sum of the match times for all the prefixes of s mod 10007.
     
    Sample Input
    1
    4
    abab
     
    Sample Output
    6
     
    Author
    foreverlin@HNU
     
    Source
    HDOJ Monthly Contest – 2010.03.06
     
     
     
    题意:给定一字符串,求它所有的前缀出现的次数的和。
    这题很纠结,一开始不知道怎么做,如果直接统计子串在主串中出现的次数,orz···肯定TLE,后来发现这题可以直接从next数组入手,因为next数组表示的是子串中最长公共前后缀串的长度,如果用dt[i]表示该字符串前i个字符中出现任意以第i个字符结尾的前缀的次数,它的递推式是 dt[i]=d[next[i]]+1,即以第i个字符结尾的前缀数等于以第next[i]个字符为结尾的前缀数加上它自己本身,这里要好好理解一下,不太好解释。
    举个例子:
                  i  1 2 3 4 5 6
            字符串  a b a b a b
            dt[i]  1 1 2 2 3 3
            aba中出现的前缀为a,aba,所以dt[3]是2,ababa中出现的前缀为a,aba,ababa,所以dt[5]是3,当i=5时,next[5]=3,所以dt[i]=dt[next[i]]+1
    理解了上面的部分就很简单了,后面直接套next数组的模板
     
     
    #include<iostream>
    #include<cstdio>
    #include<cstring>
    
    using namespace std;
    
    const int maxn=200010;
    const int mod=10007;
    
    int next[maxn],dp[maxn];
    char str[maxn];
    
    void getnext(int len){
        int i=0,j=-1;
        next[0]=-1;
        while(i<len){
            if(j==-1 || str[i]==str[j]){
                i++;j++;
                next[i]=j;
            }else
                j=next[j];
        }
    }
    
    int main(){
    
        //freopen("input.txt","r",stdin);
    
        int t,n;
        scanf("%d",&t);
        while(t--){
            scanf("%d",&n);
            scanf("%s",str);
            getnext(n);
            memset(dp,0,sizeof(dp));
            int sum=0;
            for(int i=1;i<=n;i++){
                dp[i]=(dp[next[i]]+1);
                sum=(sum+dp[i])%mod;
            }
            printf("%d\n",sum);
        }
        return 0;
    }
  • 相关阅读:
    浅谈.NET下的多线程和并行计算系列文章索引
    浅谈.NET下的多线程和并行计算(六)线程池基础下
    浅谈.NET下的多线程和并行计算(八)Winform中多线程编程基础上
    项目优化经验——垃圾回收导致的性能问题
    浅谈.NET下的多线程和并行计算(五)线程池基础上
    站点静态资源优化合并解决方案
    浅谈.NET下的多线程和并行计算(二)线程基本知识
    浅谈.NET下的多线程和并行计算(十二)CLR via C#第三版阅读笔记(1)
    原谅我的说谎
    索爱手机GPRS的OTA设置[转]
  • 原文地址:https://www.cnblogs.com/jackge/p/3032942.html
Copyright © 2020-2023  润新知